//+------------------------------------------------------------------
//+------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Cyan //Blue
#property indicator_color2 Red
#property indicator_color3 Cyan //Blue
#property indicator_color4 Red
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 4
#property indicator_width4 4


extern string TimeFrame    = "Current time frame";
extern int    Length       = 7;    // Price Channel Period
extern double Risk         = 3;    // Risk Factor in units (0...10) 
extern int    UseReEntry   = 0;    // Re-Entry Mode: 0-off,1-on
extern int    AlertMode    = 0;    // Alert Mode: 0-off,1-on
extern int    SmoothLength = 3;
extern double SmoothPhase  = 5.0;
extern int    Price        = 0;
extern bool   Interpolate  = false;
extern bool   ShowSignalOnlyOnLastBar = true;

//
//
//
//
//

double UpSignal[];
double DnSignal[]; 
double UpEntry[];
double DnEntry[]; 
double smax[];
double smin[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   SetIndexBuffer(0,UpSignal); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,108); SetIndexLabel(0,"pcUpSignal"); //dots
   SetIndexBuffer(1,DnSignal); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,108); SetIndexLabel(1,"pcDnSignal");
   SetIndexBuffer(2,UpEntry);  SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,241); SetIndexLabel(2,"pcUpRe-Entry"); //arrows
   SetIndexBuffer(3,DnEntry);  SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,242); SetIndexLabel(3,"pcDnRe-Entry");
   SetIndexBuffer(4,smax);     SetIndexLabel(4,"pcsmax");
   SetIndexBuffer(5,smin);     SetIndexLabel(5,"pcsmin");
   IndicatorShortName("RK-ml-mt-PriceChannel_Signal_on jurik("+Length+")");

      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars"); if (returnBars) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}

//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { UpSignal[0] = limit; return(0); }

   //
   //
   //
   //
   //

   if (timeFrame!= Period()) limit = MathMax(MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()),limit);
   for(i=limit; i>=0; i--)
   { 
      int y = iBarShift(NULL,timeFrame,Time[i]);
         UpSignal[i] = iCustom(NULL,timeFrame,"RK-PrCh_Signal-1",Length,Risk,UseReEntry,AlertMode,SmoothLength,SmoothPhase,Price,0,y);
         DnSignal[i] = iCustom(NULL,timeFrame,"RK-PrCh_Signal-1",Length,Risk,UseReEntry,AlertMode,SmoothLength,SmoothPhase,Price,1,y);
         UpEntry[i]  = iCustom(NULL,timeFrame,"RK-PrCh_Signal-1",Length,Risk,UseReEntry,AlertMode,SmoothLength,SmoothPhase,Price,2,y);
         DnEntry[i]  = iCustom(NULL,timeFrame,"RK-PrCh_Signal-1",Length,Risk,UseReEntry,AlertMode,SmoothLength,SmoothPhase,Price,3,y);
         smax[i]     = iCustom(NULL,timeFrame,"RK-PrCh_Signal-1",Length,Risk,UseReEntry,AlertMode,SmoothLength,SmoothPhase,Price,4,y);
         smin[i]     = iCustom(NULL,timeFrame,"RK-PrCh_Signal-1",Length,Risk,UseReEntry,AlertMode,SmoothLength,SmoothPhase,Price,5,y);

         if (ShowSignalOnlyOnLastBar)
         {
            if (UpSignal[i]!=EMPTY_VALUE && UpSignal[i+1]!=EMPTY_VALUE) UpSignal[i+1]=EMPTY_VALUE;
            if (DnSignal[i]!=EMPTY_VALUE && DnSignal[i+1]!=EMPTY_VALUE) DnSignal[i+1]=EMPTY_VALUE;
            if (UpEntry[i] !=EMPTY_VALUE && UpEntry[i+1] !=EMPTY_VALUE) UpEntry[i+1] =EMPTY_VALUE;
            if (DnEntry[i] !=EMPTY_VALUE && DnEntry[i+1] !=EMPTY_VALUE) DnEntry[i+1] =EMPTY_VALUE;
         }            
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //
         
         interpolate(smax,iTime(NULL,timeFrame,y),i);
         interpolate(smin,iTime(NULL,timeFrame,y),i);
	} 	         
   return(0);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void interpolate(double& buffer[], datetime time, int i)
{
   for (int n = 1; (i+n) < Bars && Time[i+n] >= time; n++) continue;
   
   //
   //
   //
   //
   //
   
   if (buffer[i] == EMPTY_VALUE || buffer[i+n] == EMPTY_VALUE) n=-1;
               double increment = (buffer[i+n] - buffer[i])/ n;
   for (int k = 1; k < n; k++)     buffer[i+k] = buffer[i] + k*increment;
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}